<template>
  <div class="col-md-4 gapping">
    <div class="commanContent gapping-bottom">
      <div class="row position">
        <a v-on:click="share(candidate.CANDIDATEID)">
          <img
            :src="geturl+'new-design/share.png'"
            class="icon-cus-img icon-share-gap margin-right"
          />
        </a>

        <div v-if="isAuthenticated ">
          <a title="Save" v-if="isWishlist">
            <img
              v-on:click="handleRemoveWishlist"
              class="icon-cus-img icon-wish-gap margin-right"
              :src="geturl + 'new-design/wishlist-1.png'"
            />
          </a>
          <a v-else>
            <img
              v-on:click="handleWishlist"
              class="icon-cus-img icon-wish-gap margin-right"
              :src="geturl +'new-design/notwhistlist.png'"
            />
          </a>
        </div>

        <div v-else>
          <a @click.prevent="openLoginPopup">
            <img
              class="icon-cus-img icon-wish-gap margin-right"
              :src="geturl + 'new-design/wishlist-2.png'"
            />
          </a>
        </div>
      </div>
      <div
        v-if="candidate.available_for_contract == 1"
        class="status online"
        data-toggle="tooltip"
        title="Available"
      ></div>
      <div v-else class="status offline" data-toggle="tooltip" title="Unavailable"></div>

      <ul class="listContract">
        <li>
          {{ candidate.candidate_id }} 
          <div v-if="isAuthenticated" class="box-rating consultant-start-rating">
            <span
              v-for="index in candidate.rating"
              :key="`check-${index}`"
              class="fa fa-star checked"
            ></span>
            <span
              v-for="index in (5 - candidate.rating)"
              :key="`uncheck-${index}`"
              class="fa fa-star unchecked"
            ></span>
          </div>
        </li>
      </ul>

      <div class="row rowContract">
        <a @click="redirectToDetail(candidate.CANDIDATEID)">
          <h5 class="title-1">{{ candidate.sap_job_title }}</h5>
        </a>
        <div class="col-md-12">
          <div class="cus-verticale-center">
            <div class="text-red inlineText">
              <img :src="geturl +'new-design/dollar.png'" class="icon-cus-img" />
              <span class="ml-1 gap">MYR</span>
              <span class="c-job-base-rate" id="con-copy-1">{{ candidate.base_rate || 0 }}/day</span>
              <div
                @click.prevent="calculateRate(candidate.base_rate)"
                class="iconBox iconCopy copy-to-clipboard job-tile-button-right d-inline m-l-10"
              ></div>
            </div>
          </div>
        </div>
      </div>
      <div class="row rowContract">
        <div class="col-6 col-sm-6 col-md-6 col-lg-6 col-xl-6">
          <img :src="geturl+'cus-experience.png'" class="icon-cus-img" />
          <div class="ml-1 d-inline Black">{{candidate.experience_in_years}} years exp.</div>
        </div>

        <div
          class="col-sm-12 col-lg-6 unavalibale"
          :class="{ 'disabled': candidate.willing_to_travel == 0 }"
        >
          <img :src="geturl+'cus-group-6.png'" class="icon-cus-img will-travel-img" />
          <div
            class="ml-1 d-inline Black"
            :class="{ 'disabled': candidate.willing_to_travel == 0 }"
          >
            <span v-if="candidate.willing_to_travel == 1">Ok to Travel</span>
            <span v-else>Travel</span>
          </div>
        </div>
      </div>
      <div class="row rowContract">
        <div class="col-sm-12 col-lg-6">
          <img :src="geturl+'cus-month.png'" class="icon-cus-img" />
          <div class="ml-1 d-inline Black">{{candidate.notice_period_days}} days</div>
        </div>

        <div class="col-sm-12 col-lg-6 unavalibale" :class="{ 'disabled': candidate.project == 0 }">
          <img :src="geturl+'cus-Group-9.png'" class="icon-cus-img" />
          <div class="ml-1 d-inline Black" :class="{ 'disabled': candidate.project == 0 }">Project</div>
        </div>
      </div>
      <div class="row rowContract">
        <div class="col-sm-12 col-lg-6">
          <img :src="geturl+'cus-start.png'" class="icon-cus-img" />
          <div class="ml-1 d-inline Black">{{candidate.availability_date}}</div>
        </div>

        <div class="col-sm-12 col-lg-6 unavalibale" :class="{ 'disabled': candidate.support == 0 }">
          <img :src="geturl+'cus-Group-3.png'" class="icon-cus-img" />
          <div class="ml-1 d-inline Black" :class="{ 'disabled': candidate.support == 0 }">Support</div>
        </div>
      </div>
      <div class="row rowContract">
        <div
          class="col-sm-12 col-lg-6 unavalibale"
          :class="{ 'disabled': candidate.full_time == 0 }"
        >
          <img :src="geturl+'cus-ull-time.png'" class="icon-cus-img" />
          <div
            class="ml-1 d-inline Black"
            :class="{ 'disabled': candidate.full_time == 0 }"
          >Full Time</div>
        </div>

        <div class="col-sm-12 col-lg-6">
          <img :src="geturl+'cus-location.png'" class="icon-cus-img" />
          <div class="ml-1 d-inline Black">{{ candidate.city || "N/A" }}</div>
        </div>
      </div>

      <div class="row rowContract">
        <div
          class="col-sm-12 col-lg-6 unavalibale"
          :class="{ 'disabled': candidate.part_time == 0 }"
        >
          <img :src="geturl+'cus-Group-8.png'" class="icon-cus-img" />
          <div
            class="ml-1 d-inline Black"
            :class="{ 'disabled': candidate.part_time == 0 }"
          >Part Time</div>
        </div>
      </div>

      <div v-if="user.role_id == 1" class="boxbtns job-tile-button-right">
        <div class="row no-gutters border-top-btn">
          <div class="col-md-6 border-right-btn">
            <div v-if="!isCompare">
              <img v-if="isLoadingCompare" :src="geturl+'loader.svg'" class="consultant-img-loader" />
              <a
                v-else
                title="Add to Compare"
                @click.prevent="handleCompare"
                class="btn btn-custom-trans colorBlue btn-block addcompare-icon"
              >Compare</a>
            </div>

            <div v-else>
              <img v-if="isLoadingCompare" :src="geturl+'loader.svg'" class="consultant-img-loader" />
              <a
                v-else
                title="Add to Compare"
                @click.prevent="handleRemoveCompare"
                class="btn btn-custom-trans colorBlue btn-block addcompare-icon"
              >Remove Compare</a>
            </div>
          </div>
          <div class="col-md-6">
            <div v-if="!isRequested">
              <img v-if="isLoadingRequest" :src="geturl+'loader.svg'" class="consultant-img-loader" />
              <a v-else
                @click.prevent="handleRequestProfile(candidate.id)"
                title="Request Profile"
                class="btn btn-custom-trans colorRed btn-block"
              >
                <img :src="geturl+'request-profile.png'" class="icon-cus-img" />
                Request Profile
              </a>
            </div>
            <div v-else>
              <a
                title="Cancel Requested"
                class="btn btn-custom-trans colorRed btn-block"
                @click.prevent="handleCancelRequest(candidate.id)"
              >Cancel Request</a>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import api from "../../api/consultant";
export default {
  props: {
    candidate: {
      type: Object
    },
    user: {
      type: Object
    },
    totalCompare: {
      type: Number
    }
  },
  data() {
    return {
      countryCode: null,
      isLoadingCompare: false,
      isLoadingWishlist: false,
      isLoadingRequest: false
    };
  },
  computed: {
    geturl: function() {
      let curr = process.env.MIX_API_URL;
      this.fullurl = curr + "/public/images/";
      return this.fullurl;
    },
    isAuthenticated() {
      if (this.user.role_id === 0) return false;
      return true;
    },
    isCompare() {
      let normalizedComparison = this.candidate.comparison.filter(candidate => {
        return candidate.CLIENTID == this.user.zoho_id;
      });

      if (normalizedComparison.length > 0) return true;
      return false;
    },
    isRequested() {
      let normalizedComparison = this.candidate.profile_requests.filter(
        candidate => {
          return candidate.CONTACTID == this.user.CONTACTID;
        }
      );

      if (normalizedComparison.length > 0) return true;
      return false;
    },
    isWishlist() {
      let normalizedComparison = this.candidate.wishlist.filter(candidate => {
        return candidate.CLIENTID == this.user.zoho_id;
      });

      if (normalizedComparison.length > 0) return true;
      return false;
    },
    isRequest() {
      return true;
    }
  },
  methods: {
    calculateRate(rate) {
      this.$notify({
        group: "foo",
        title: "Notification",
        text: "Your Billing Rate has been Copied !"
      });
      this.$emit("calculate-rate", parseFloat(rate));
    },
    handleRequestProfile(id) {
      this.isLoadingRequest = true;
      api
        .requestProfile(this.countryCode, id)
        .then(res => {
          this.$emit("refresh-jobs");
          $(toastr.success("Successfully request this profile"));
        })
        .catch(err => {
          $(toastr.error("Failed to request this profile"));
        })
        .finally(() => {
          this.isLoadingRequest = false;
        });
    },
    handleCancelRequest(id) {
      api
        .cancelRequestProfile(this.countryCode, id)
        .then(res => {
          this.$emit("refresh-jobs");
          $(toastr.success("Successfully cancelled the request"));
        })
        .catch(err => {
          $(toastr.error("Failed to cancel this request"));
        });
    },
    share(id) {
      let url =
        process.env.MIX_API_URL +
        "/" +
        this.countryCode +
        "/consultants-details/" +
        id;
      this.$clipboard(url);
      this.$notify({
        group: "foo",
        title: "Message",
        text: "Profile URL has been copied!"
      });
    },
    redirectToDetail(id) {
      window.location.replace(
        process.env.MIX_API_URL +
          "/" +
          this.countryCode +
          "/consultants-details/" +
          id
      );
    },
    openLoginPopup() {
      $("html, body").animate({ scrollTop: 0 }, "slow");
      event.stopPropagation();
      $(".forgot-form-block").hide();
      $(".login-form-toggle").toggle(200);
      $(".login-form-block").show(200);
    },
    handleCompare() {
      if (this.user.role_id === 0) {
        this.openLoginPopup();
        return;
      }
      if (this.totalCompare > 2) {
        $(toastr.error("Maximum add three consultant"));
        return;
      }
      let data = {
        _token: document.head
          .querySelector('meta[name="csrf-token"]')
          .getAttribute("content"),
        consultant_id: this.candidate.candidate_id,
        db_id: this.candidate.id
      };
      this.isLoadingCompare = true;
      api
        .addToCompare(this.countryCode, data)
        .then(() => {
          this.$emit("refresh-jobs");
          this.$emit("fetch-compare");
          $(toastr.success("consultant has been added to compare."));
        })
        .catch(() => {
          $(toastr.error("Maximum add three consultant"));
        })
        .finally(() => {
          this.isLoadingCompare = false;
        });
    },
    handleRemoveCompare() {
      if (this.user.role_id === 0) {
        this.openLoginPopup();
        return;
      }
      let data = {
        _token: document.head
          .querySelector('meta[name="csrf-token"]')
          .getAttribute("content"),
        id: this.candidate.candidate_id
      };
      this.isLoadingCompare = true;
      api
        .deleteCompare(this.countryCode, data)
        .then(() => {
          this.$emit("refresh-jobs");
          this.$emit("fetch-compare");
          $(toastr.error("consultant has been Remove to compare."));
        })
        .catch(() => {
          $(toastr.error("Consultant not founded"));
        })
        .finally(() => {
          this.isLoadingCompare = false;
        });
    },
    handleWishlist() {
      if (this.user.role_id === 0) {
        this.openLoginPopup();
        return;
      }
      let data = {
        id: this.candidate.id,
        consultant_id: this.candidate.candidate_id,
        db_id: this.candidate.id
      };
      this.isLoadingWishlist = true;
      api
        .addWishlist(this.countryCode, data)
        .then(() => {
          this.$emit("refresh-jobs");
          $(toastr.success("Profile has been added to wishlist successfully."));
        })
        .catch(() => {
          $(toastr.error("Consultant not founded"));
        })
        .finally(() => {
          this.isLoadingWishlist = false;
        });
    },
    handleRemoveWishlist() {
      if (this.user.role_id === 0) {
        this.openLoginPopup();
        return;
      }
      let data = {
        _token: document.head
          .querySelector('meta[name="csrf-token"]')
          .getAttribute("content"),
        consultant_id: this.candidate.candidate_id
      };
      this.isLoadingWishlist = true;
      api
        .removeWishlist(this.countryCode, data)
        .then(() => {
          this.$emit("refresh-jobs");
          $(toastr.error("Profile has been removed to your wishlist."));
        })
        .catch(() => {
          $(toastr.error("Profile alredy removed to your wishlist."));
        })
        .finally(() => {
          this.isLoadingWishlist = false;
        });
    }
  },
  mounted() {
    // Search Country Code
    let url = window.location.href;
    if (window.location.href.search("MY")) {
      this.countryCode = "MY";
    } else {
      this.countryCode = "PH";
    }
  }
};
</script>
<style>
.listContract {
  margin-left: -5px !important;
}
.icon-share-gap {
  margin-right: 10px;
}

.icon-wish-gap {
  margin-right: 16px;
}
.position {
  float: right;
}
.icon-cus-img {
  height: 16px !important;
  width: 16px !important;
}

.title-1 {
  overflow: hidden;
  height: 32px;
  line-height: 16px;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  -o-text-overflow: ellipsis;
  text-overflow: ellipsis;
}
.gapping {
  padding-right: 5px !important;
  padding-left: 5px !important;
}
.gapping-bottom {
  margin-bottom: 10px !important;
}
.icon-cus-img {
  margin-right: 0px !important;
}

.margin-right {
  margin-right: 10px !important;
}
.transparent {
  display: none;
}
.gap-right {
  margin-right: 20px;
}
</style>